/* compilare con gcc -o stampaalbero stampaalbero.c searchtree.c */
#include <stdio.h>
#include "searchtree.h"

/* inserisce, uno per volta, gli n interi letti dal file puntato da fp in un searchtree */
/* restituisce la radice del searchtree cosi' costruito */
searchtree *loadtree(FILE *fp, int n)
{
	int i,k;
	searchtree *p = createsearchtree();

	for(i = 0; i < n; i++) {
		fscanf(fp,"%d",&k);
		p = insert(p,k);
	}
	return p;
}

/* visita inorder dell'albero con memorizzazione del livello in cui occorre un nodo */
/* Si provi a sostituire p->left con p->right, e viceversa. Come cambia l'output? */
void stampaalbero(searchtree *p, int level)
{
	int i;

	if(p) {
		stampaalbero(p->left,level+1);

		/* stampa tanti spazi quanti sono i livelli precedenti al livello del nodo da stampare */
		for(i = 0; i < level; i++)
			printf("     ");
		printf("[%3d]\n",p->v);

		stampaalbero(p->right,level+1);
	}
}

/* stampa l'albero di radice p in forma trasposta */
void printsearchtree(searchtree *p)
{
	/* richiama la funzione ricorsiva stampaalbero */
	/* passando la radice e il livello 0 */
	stampaalbero(p,0);
}

int main(int ac, char **av)
{	
	FILE *fp;
	int n;
	searchtree *root;

	if(ac != 3 || !(n = atoi(av[1])) ) {
		fprintf(stderr,"Uso: %s <n (n>0) > <file>\n",av[0]);
		exit(-1);
	};
	if(!(fp = fopen(av[2],"r"))) {
	fprintf(stderr,"File %s non trovato\n",av[2]);
		exit(-2);
	};	
	
	/* inserisce gli elementi dal file in un searchtree di radice root */
	root = loadtree(fp,n);

	/* stampa l'albero in forma trasposta */
	printsearchtree(root);

	return 0;
}
